from math import sqrt, sin, cos, floor

def vfloor(v):
  return (floor(v[0]), floor(v[1]))

def mul(v,s):
  return v[0]*s,v[1]*s

def addvec(v1, v2):
  return v1[0] + v2[0], v1[1] + v2[1]

def subvec(v1, v2):
  return v1[0] - v2[0], v1[1] - v2[1]

def vmag(v1):
  return sqrt((v1[0] ** 2) + (v1[1] ** 2))

def rad2vec(rads):
  return cos(rads), sin(rads)

def normalize(v1):
  mag = vmag(v1)
  if mag < 0.00001:
    return (0,0)
  return mul(v1, 1.0/mag)

def dot(v1, v2):
  return v1[0] * v2[0] + v1[1] * v2[1]